%%% File    : lecture2.erl
%%% Author  :  <John Hughes@HALL>
%%% Description : 
%%% Created : 21 May 2009 by  <John Hughes@HALL>

-module(lecture2).
-include_lib("eqc/include/eqc.hrl").

-compile(export_all).

%% A generator for symbolic dictionaries

dict() ->
    ?LAZY(oneof([{call,dict,new,[]},
		 ?LETSHRINK([D],[dict()],
			    {call,dict,store,[key(),value(),D]})])).

%% Auxiliary generators

key() ->
    oneof([int(),atom()]).

value() ->
    key().

atom() ->
    elements([a,b,c,undefined]).

%% Dictionaries constructed using from_list behave like property lists

prop_dict() ->
  ?FORALL(L,list({key(),value()}),
    ?IMPLIES(L/=[],
      ?FORALL(K,elements(proplists:get_keys(L)),
	      equal(proplists:get_value(K,L) ,
		    dict:fetch(K,dict:from_list(L)))))).

%% Hoare testing: the model

model(Dict) ->
    dict:to_list(Dict).

%% Hoare testing of store

model_store(K,V,L) ->
    [{K,V}|L].

prop_store() ->
    ?FORALL({K,V,D},
	    {key(),value(),dict()},
	    begin
		Dict = eval(D),
		equal(model(dict:store(K,V,Dict)),
		      model_store(K,V,model(Dict)))
	    end).

%% Property auxiliary

equal(X,Y) ->
    ?WHENFAIL(io:format("~p /= ~p~n",[X,Y]),
	      X==Y).
